#!/user/local/bin/ruby -Ks
def showHelp; scrName = File::basename($0.gsub(/\\/, '/'));
puts <<"================================================"
#{scrName} v1.01  Copyright (C) 2005, nomad
Tv: OED CD-ROM  v3.0xAv3.1 ̎f[^eLXg`ɕϊ
\: ruby -Ks #{scrName} <inDir> [<outDir>]
  <inDir>   .htm t@ĈfBNg
  <outDir>  o̓fBNg (wȂȂJgfBNg)
:
  ruby -Ks #{scrName} "C:\\Program Files\\OED\\OED CD v3\\Data" D:\\OED
================================================
end
=begin
o: *.txt  f[^̃eLXgt@C
:
  v1.00 2005-08-21 by nomad
    J
  v1.10 2005-10-18 by nomad
    OED v3.01AV3.1 ɑΉ
    datafile.rb ɉǕ𕪊
: Copyright (C) 2005, nomad. I[v\[X
=end

scrPath = File::dirname(__FILE__.gsub(/\\/, '/')) + '/'
require scrPath + 'datafile.rb'
include OED

### 萔

  FILE_COUNT = 10       # .htm t@C
  BLK_COUNT  = 1000     # ubN

### Tu[`

# pX̃pX؂̍폜
def pathchomp(path)
  path.chop! if path[-1] == File::Separator
  path
end

# vbgtH[
def platform
  if RUBY_PLATFORM =~ /mswin|cygwin|mingw|bccwin/i  # wince??
    :win32
  elsif RUBY_PLATFORM =~ /os2/i
    :os2
  elsif RUBY_PLATFORM =~ /djgpp/i    # ???
    :dos
  elsif RUBY_PLATFORM =~ /linux/i
    :linix
  else
    :unknown
  end
end

# l 3 J}؂
def comma(num)
  num = num.to_s unless num.kind_of?(String)
  num.gsub(/(\d)(?=\d{3}+$)/, '\\1,')
end

# oߕ\

def showProgress(dataSize, percent, start)
  t = Time::now
  e = (t - start).round
  STDERR.print "%s bytes %5.1f%% decoded, %s elapsed\r" %
    [comma(dataSize), percent, Time::at(e).utc.strftime('%X')]
end

def showProgressLast(dataSize, percent, start)
  showProgress(dataSize, percent, start)
  STDERR.print "\n"
end

# pX؂蕶̕ϊ

class String
  def toslash
    self.gsub(/\\/, '/')
  end
  def toyen
    self.gsub(/\//, '\\')
  end
end

### 1 t@C

def decodeFile(inf, outFname)

  # o̓ubNTCY̌
  #   ro߂ 0.1% Pʂŕ\邱Ƃɂ
  #   o͒Pʂɂ킹邱Ƃɂ
  dataSize = inf.stat.size - inf.offset
  blkSize = dataSize / BLK_COUNT

  # f[^o
  n = 0   # ̓oCg

  STDERR.puts "%s --> %s" % [inf.path, outFname]
  open(outFname, 'wb') do |outf|

    # ubNo
    start = Time::now
    blockCount = ($DEBUG) ? 1 : BLK_COUNT + 1
    blockCount.times do |blkn|
      showProgress(dataSize, blkn * 100.0 / BLK_COUNT, start)
      data = inf.decode(n, blkSize)
      outf.write(data)
      n += data.size
    end

    showProgressLast(dataSize, n * 100.0 / dataSize, start)

  end

end

def openfile(inFname, num)

  f = createDataFileObject(inFname, num)
  if f.nil?
    STDERR.puts 'Unknown file format: ' + inFname
    return nil
  end
  f.setup
  version = f.version
  if version == V_UNKNOWN
    STDERR.puts 'Unknown version: ' + inFname
    return nil
  end

  f
end

### C

def main(inDir, outDir)
  scrPath = File::dirname($0)

  # t@CAJԂ
  FILE_COUNT.times do |num|

    # o̓t@Č
    inFname = File::join(inDir, '%d.htm' % [num + 1])
    unless File::exist?(inFname)   # ̓t@CȂ΃XLbv
      STDERR.puts inFname + ' not found'
      next
    end

    outFname = File::join(outDir, '%d.txt' % [num + 1])

    # ̓t@C̊mF
    inf = openfile(inFname, num)
    next if inf.nil?

    # 
    if $DEBUG
      decodeFile(inf, outFname)
    else
      case platform
      when :os2, :win32
        case inf.version
        when V300 then version = '300'
        when V301 then version = '301'
        when V310 then version = '310'
        end
        inf.close
        case platform
        when :os2
          cmd = File::join(scrPath, 'oed2txt-os2.exe')
          system(%Q!#{cmd.toyen} ^"#{inFname.toyen}^" ^"#{outFname.toyen}^" #{version}!)
        when :win32
          cmd = File::join(scrPath, 'oed2txt-win.exe')
          system(%Q!#{cmd.toyen} "#{inFname.toyen}" "#{outFname.toyen}" #{version}!)
        end
      else
        decodeFile(inf, outFname)
      end
    end

    inf.close unless inf.closed?
  end

end

### OE㏈

  # ̏
  begin
    raise "\n.htm t@ĈfBNgw肵Ă" if ARGV.size < 1
  rescue => e
    showHelp()
    STDERR.puts e.message
    exit 1
  end
  inDir = ARGV.shift
  inDir = pathchomp(inDir.toslash)
  outDir = ARGV.shift || '.'
  outDir = pathchomp(outDir.toslash)

  start = Time::now
  STDERR.print "Jn: ", start.strftime('%Y-%m-%d %X'), "\n"

  main(inDir, outDir)

  finish = Time::now
  STDERR.print "I: ", finish.strftime('%Y-%m-%d %X'), "\n"
  STDERR.print ": ", Time::at(finish.to_i - start.to_i).utc.strftime('%X'), "\n"
